/**
 * Renders the canonical URL of the static directory. This is defined in
 * the apps.properties file, where the application's mounting is done.
 * 
 * @param {Sting} path to append to the mountpoint
 * @member Global
 */
var staticUrl_macro = function(param) {
    return app.getAppsProperties()["staticMountpoint"] + "/" + (param.path || "");
}

var loginMask_macro = function() {
   if (session.user) {
      return session.user.renderSkinAsString("loginMask");
   }
   return root.renderSkinAsString("loginMask");
}
